#!/usr/bin/env python
# -*- coding: utf-8 -*-

import dialog
import os
from connection_wizard import ConnectionWizard
from connection_editor import ConnectionEditor
import connection_utils 
import subprocess

def createMainMenu(d):
    """
    Главное меню
    """
    return d.menu(
        "Выберите способ настройки",
        width=40, height=10, menu_height=3,
        choices=[
            ("wizard", "Мастер соединения"),
            ("manual", "Ручная настройка"),
            ("quit", "Выйти")
        ])

def main():
    """
    main function
    """
    wvDialConfig = "/linuxcash/cash/3g-support/wvdial.conf";
    wvDialConfigTmp = "/tmp/wvdial.conf";
    subprocess.call("cp " + wvDialConfig + " " + wvDialConfigTmp, shell = True)
    d = dialog.Dialog()
    d.add_persistent_args(("--backtitle", "Настройка мобильного соединения"))
    wizard = ConnectionWizard(d, wvDialConfig, wvDialConfigTmp)
    editor = ConnectionEditor(d, wvDialConfig, wvDialConfigTmp)
    isExit = False
    d.infobox("Остановка сервиса мобильного подключения", height=6)
    wvDialStop = subprocess.Popen(['sudo', 'service', 'artix-3g-support', 'stop'], stdout=subprocess.PIPE, stderr=subprocess.PIPE)
    wvDialStop.wait()
    try:
        while not isExit:
            (code, tag_of_main_menu) = createMainMenu(d)
            if code == d.DIALOG_OK:
                if tag_of_main_menu == "wizard":
                    wizard.run()
                elif tag_of_main_menu == "manual":
                    editor.run()
                else:
                    isExit = True
            else:
                isExit = True

    except KeyboardInterrupt:
        d.msgbox("Программа была завершена", height=6)
    subprocess.Popen(['sudo', 'service', 'artix-3g-support', 'start'], stdout=subprocess.PIPE, stderr=subprocess.PIPE)

if __name__ == "__main__":
    os.chdir(os.path.dirname(os.path.abspath(__file__)))
    main()
